/*
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED.
 *  United States Government Sponsorship acknowledged. Any commercial use must be
 *  negotiated with the Office of Technology Transfer at the California Institute
 *  of Technology.
 *
 *  This software may be subject to U.S. export control laws and regulations.
 *  By accepting this document, the user agrees to comply with all applicable U.S.
 *  export laws and regulations.  User has the responsibility to obtain export
 *  licenses, or other export authority as may be required before exporting such
 *  information to foreign countries or providing access to foreign persons.
 */
                                                                                                        
package suramadu.util;

/**
 * The MapKey should be used to create keys for use in Maps, or as a 
 * Java for of Enumerated Type.
 * @author Brian Giovannoni
 * @version $Id: Key.java,v 1.1 2004/09/23 15:34:23 mbi Exp $
 */
public class Key {

	/**
	 * Check equality with the given object.
	 * @param that
	 *            Does this == that?
	 */
	public boolean equals(Object that) {
		return (System.identityHashCode(this) == System.identityHashCode(that));
	}

	public static void main(String args[]){
		Key one = new Key();
		Key two = new Key();
		Key three = new Key();
		
		System.out.println(" one = two? " + one.equals(two));
		System.out.println(" one = three? " + one.equals(three));
		System.out.println(" one = one? " + one.equals(one));
	}
}
