/** 
 * $Id: PropertyValidationException.java,v 1.1 2004/09/23 15:34:23 mbi Exp $
 * 
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED. 
 *  United States Government Sponsorship acknowledged. Any commercial use must be 
 *  negotiated with the Office of Technology Transfer at the California Institute 
 *  of Technology. 
 *
 *  This software may be subject to U.S. export control laws and regulations.  
 *  By accepting this document, the user agrees to comply with all applicable U.S. 
 *  export laws and regulations.  User has the responsibility to obtain export 
 *  licenses, or other export authority as may be required before exporting such 
 *  information to foreign countries or providing access to foreign persons. 
 */

package suramadu.util.exec;

/**
 * The PropertyValidationException class serves to signal failure of property validation. Examples
 * of these failures are improper parsing of values from property files, or logical failures of
 * property values. <B>ToDo: </B>
 * <P>
 * </P>
 * 
 * @author Vanessa Carson
 * @version $Id: PropertyValidationException.java,v 1.1 2004/09/23 15:34:23 mbi Exp $
 */

public class PropertyValidationException extends Exception {

    public PropertyValidationException( String message ) {
        super( message );
    }

    public PropertyValidationException( Exception e ) {
        super( e.getMessage() );
    }

    public PropertyValidationException( Exception e, String message ) {
        super( e.getClass().getName() + "\n" + e.getMessage() + "\n" + message );
    }

}