/*
 * ThreadLauncher.java Created on August 8, 2003, 2:09 PM
 * 
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED. 
 *  United States Government Sponsorship acknowledged. Any commercial use must be 
 *  negotiated with the Office of Technology Transfer at the California Institute 
 *  of Technology. 
 *
 *  This software may be subject to U.S. export control laws and regulations.  
 *  By accepting this document, the user agrees to comply with all applicable U.S. 
 *  export laws and regulations.  User has the responsibility to obtain export 
 *  licenses, or other export authority as may be required before exporting such 
 *  information to foreign countries or providing access to foreign persons. 
 */

package suramadu.util.exec;

/**
 * @author mbi
 */

public interface ThreadLauncher {
    public void kill();

    public Thread launch();

    public Thread launchDaemon();

    /**
     * 
     * @uml.property name="thread"
     */
    public Thread getThread();

    
    public void setIterations( int iterations );

    public int getIterations();

    public void setPriority( int priority );

    public int getPriority();

    public void setPeriod( long period );

    public long getPeriod();

    public void setInitialDelay( long delay );

    public long getInitialDelay();

    /**
     * 
     * @uml.property name="threadType"
     */
    public void setThreadType(ThreadType threadType);

    /**
     * 
     * @uml.property name="threadType"
     * @uml.associationEnd 
     * @uml.property name="threadType" multiplicity="(0 1)"
     */
    public ThreadType getThreadType();

    /**
     * 
     * @uml.property name="memoryType"
     */
    public void setMemoryType(MemoryType memoryType);

    /**
     * 
     * @uml.property name="memoryType"
     * @uml.associationEnd 
     * @uml.property name="memoryType" multiplicity="(0 1)"
     */
    public MemoryType getMemoryType();

    public void setData( ThreadLauncherData data );
}