/*
 * Created on Jun 7, 2004 
 * 
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED. 
 *  United States Government Sponsorship acknowledged. Any commercial use must be 
 *  negotiated with the Office of Technology Transfer at the California Institute 
 *  of Technology. 
 *
 *  This software may be subject to U.S. export control laws and regulations.  
 *  By accepting this document, the user agrees to comply with all applicable U.S. 
 *  export laws and regulations.  User has the responsibility to obtain export 
 *  licenses, or other export authority as may be required before exporting such 
 *  information to foreign countries or providing access to foreign persons. 
 */
package suramadu.util.exec;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * @author dan FIXME REMOVE FROM REPOSITORY WE DON'T NEED THIS..... This should be encapilated in the Wrapper Types
 */
public class ThreadType {
    static class ThreadTypeException extends RuntimeException {
        ThreadTypeException() {
            super();
        }
        
        ThreadTypeException( String msg ) {
            super( msg );
        }
    }

    /** Thread type enumerations */
    public static final ThreadType JAVATHREAD           = new ThreadType();
    public static final ThreadType PERIODICJAVATHREAD   = new ThreadType();
    public static final ThreadType REALTIMETHREAD       = new ThreadType();
    public static final ThreadType NOHEAPREALTIMETHREAD = new ThreadType();

    /** property value map to memory types */
    private static Map             THREADTYPEMAP        = new HashMap();
    static {
        THREADTYPEMAP.put( "JAVA", JAVATHREAD );
        THREADTYPEMAP.put( "PERIODICJAVA", PERIODICJAVATHREAD );
        THREADTYPEMAP.put( "RT", REALTIMETHREAD );
        THREADTYPEMAP.put( "NHRT", NOHEAPREALTIMETHREAD );
    }

    public static ThreadType getThreadType( String threadType ) {
        ThreadType tt = (ThreadType)THREADTYPEMAP.get( threadType.trim().toUpperCase() );

        if ( null == tt ) {
            StringBuffer mb = new StringBuffer();
            
            mb.append( "thread type must be: " );
            int count = 0;
            for ( Iterator i = ThreadType.getTypeNames(); i.hasNext(); count++ ) {
                if ( 0 != count ) mb.append( ", " );
                mb.append( "\"" + i.next() + "\"" );
            }
            mb.append( ", and not \"" + threadType + "\"" );

            throw new ThreadType.ThreadTypeException( mb.toString() );
        }
        
        return tt;
    }
    
    public static Iterator getTypeNames() {
        return THREADTYPEMAP.keySet().iterator();
    }

    private static int             nextID               = 0;

    private static String[] TYPEINDEX = new String[ 4 ];
    static {
        for ( Iterator i = getTypeNames(); i.hasNext(); ) {
            String     tname = (String)i.next();
            ThreadType tt    = getThreadType( tname );
            TYPEINDEX[ tt.id ] = tname;
        }
    }
    
    private int                    id;

    protected ThreadType() {
        assignID();
    }

    private synchronized void assignID() {
        id = nextID++;
    }

    /**
     * Indicates whether some other object is "equal to" this one.
     */
    public boolean equals( Object obj ) {
        if ( obj instanceof ThreadType ) {
            return (id == ((ThreadType)obj).id);
        }
        else
            return false;
    }

    public String toString() {
        return super.toString() + ": " + TYPEINDEX[ id ] + " (id=" + id + ")";
    }
}