/*
 * Created on Jun 7, 2004
 *
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED.
 *  United States Government Sponsorship acknowledged. Any commercial use must be
 *  negotiated with the Office of Technology Transfer at the California Institute
 *  of Technology.
 *
 *  This software may be subject to U.S. export control laws and regulations.
 *  By accepting this document, the user agrees to comply with all applicable U.S.
 *  export laws and regulations.  User has the responsibility to obtain export
 *  licenses, or other export authority as may be required before exporting such
 *  information to foreign countries or providing access to foreign persons.
 */

package suramadu.util.time;

import java.util.Vector;

/**
 * @author dan
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TimeStampLog {

    /**
     * 
     * @uml.property name="timeStamps"
     * @uml.associationEnd 
     * @uml.property name="timeStamps" multiplicity="(0 -1)" elementType="java.lang.Long"
     */
    Vector timeStamps = new Vector();


    /**
     * @param numValues
     */
    public TimeStampLog( int numValues ) {

        timeStamps.setSize( numValues );
    }

    /**
     * 
     * @uml.property name="timeStamps"
     */
    public Vector getTimeStamps() {
        return timeStamps;
    }

    /* Append timestamp to end of vector */
    public void addTimeStamp( long time ) {
        timeStamps.add( new Long( time ) );
    }

    public void addTimeStamp( int index, long time ) {
        if ( timeStamps.capacity() < index ) {
            timeStamps.setSize( index );
        }
        timeStamps.setElementAt( new Long( time ), index );
    }

    public long[] compare( TimeStampLog otherLog, int numElements ) {
        long diffs[] = new long[ numElements ];

        Vector otherStamps = otherLog.getTimeStamps();

        for ( int index = 0; index < numElements; index++ ) {
            Long thisStamp = (Long)timeStamps.elementAt( index );
            Long otherStamp = (Long)otherStamps.elementAt( index );

            long thisVal = 0;
            if (thisStamp != null) {
              thisVal = thisStamp.longValue();
            } else { 
              System.out.println("Null this val: " + index);
            }
            long otherVal = 0;
            
            if (otherStamp != null )
            {
              otherVal = otherStamp.longValue();
            } else {
              System.out.println("Null other val: " + index);
            }
			//System.out.println("Compare: " + index + " this "
			//		  + thisVal + " other " + otherVal );
						  
            diffs[ index ] = Math.abs( (long)thisVal - otherVal );
            // System.out.println("Diff " + index + " " + diffs[index]);
        }

        return diffs;
    }

	/**
	 * @param i
	 */
	public long getElementAt(int i) {
		
		Long doub = null;
		try {
	      doub = (Long) timeStamps.elementAt(i);
		  if (doub == null) 
		  {
		  	// System.out.println("TimeStampLog: getElementAt(i) is null, i=" + i);
		    return -1;
		  }
		} catch (Exception e)
		{
			e.printStackTrace();
		  System.out.println("Exception retrieving long val");
		  return -1;
		}
	    long longVal = doub.longValue();

	    return longVal;
	}

	public long[] toArray(int numElements)
	{
	  long[] arr = new long[numElements];

	  int len = arr.length;
	  
	  for (int index = 0; index < len; index++){
	  	arr[index] =  getElementAt(index);
	  }
	  
	  return arr;
	  	
	}
	public void print ()
	{
	  int len = timeStamps.size();
	  for (int index = 0; index < len; index++)
	  {
	  	System.out.println("El " + index + " " + timeStamps.elementAt(index));
	  }
	}
}

