/*
 * Created on Jul 8, 2004
 * 
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED. 
 *  United States Government Sponsorship acknowledged. Any commercial use must be 
 *  negotiated with the Office of Technology Transfer at the California Institute 
 *  of Technology. 
 *
 *  This software may be subject to U.S. export control laws and regulations.  
 *  By accepting this document, the user agrees to comply with all applicable U.S. 
 *  export laws and regulations.  User has the responsibility to obtain export 
 *  licenses, or other export authority as may be required before exporting such 
 *  information to foreign countries or providing access to foreign persons. 
 */
package suramadu.tests.latency;
/**
 * @author dan
 * 
 * @see Synchronization
 */

import suramadu.util.time.Time;


public class SynchronizationResource {
  private static long enterTime;
  private static long leaveTime;
  
  public synchronized static void synchMethod()
  {
  	// Take timestamp upon entering
  	enterTime = Time.getCycles();
  	
  	// And again upon leaving
  	leaveTime = Time.getCycles();
  }

  public static void normalMethod()
  {
	// Take timestamp upon entering
	enterTime = Time.getCycles();
  	
	// And again upon leaving
	leaveTime = Time.getCycles();
  }

    /**
     * 
     * @uml.property name="enterTime"
     */
    public static long getEnterTime() {
        return enterTime;
    }

    /**
     * 
     * @uml.property name="leaveTime"
     */
    public static long getLeaveTime() {
        return leaveTime;
    }

}
