/*
 *  Copyright 2004, by the California Institute of Technology. ALL RIGHTS RESERVED.
 *  United States Government Sponsorship acknowledged. Any commercial use must be
 *  negotiated with the Office of Technology Transfer at the California Institute
 *  of Technology.
 *
 *  This software may be subject to U.S. export control laws and regulations.
 *  By accepting this document, the user agrees to comply with all applicable U.S.
 *  export laws and regulations.  User has the responsibility to obtain export
 *  licenses, or other export authority as may be required before exporting such
 *  information to foreign countries or providing access to foreign persons.
 */
 
package suramadu.tests.throughput;

/**
 * This test exercises Java's arithmetic capabilities to measure throughput during computationally
 * intensive operations with floating point numbers, indexing, and looping.
 * <p>
 * <B><I>PURPOSE: </I> </B> To measure the Java and RTSJ computational throughput with floating
 * point arithmatic, indexing and looping.
 * <p>
 * <B><I>DESIGN: </I> </B> This test runs a series of quaternion operations in a loop. Each loop
 * executes the function DoKfsFullQuat, which does the operations. The operations involve a lot of
 * floating point aritmetic as well as array indexing and looping. The action of DoKfsFullQuat is
 * representative of actual computations done in the navigation of a spacecraft.
 * <p>
 * <B><I>ASSUMPTIONS: </I> </B>
 * <p>
 * <B><I>INPUTS: </I> </B> <table>
 * <tr>
 * <th align="left">Property</th>
 * <th align="right">Default Value</th>
 * <th align="left">Description</th>
 * </tr>
 * <tr>
 * <td>"iterations"</td>
 * <td>"1000000"</td>
 * <td>The number of test iterations to perform.</td>
 * </tr>
 * <tr>
 * <td>"printTimeDeltas"</td>
 * <td>"No"</td>
 * <td>Indicates whether or not to print all of the time deltas.</td>
 * </tr>
 * </table>
 * <p>
 * <B><I>OUTPUTS: </I> </B>
 * <p>
 * <B><I>EXAMPLES: </I> </B>*
 * <p>
 * <B><I>ORIGINS: </I> </B>
 * <p>
 * 
 * @author Alex Murray
 */
class KfsFullQuat {
}